// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisCam.pas' rev: 5.00

#ifndef VisCamHPP
#define VisCamHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisComp.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Viscam
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TVisCamera;
class PASCALIMPLEMENTATION TVisCamera : public Viscomp::TVisTransformed 
{
	typedef Viscomp::TVisTransformed inherited;
	
private:
	float FViewNear;
	float FViewFar;
	Visclass::TVisMatrix* FMatrix;
	void __fastcall WriteViewNear(Classes::TWriter* Writer);
	void __fastcall WriteViewFar(Classes::TWriter* Writer);
	void __fastcall SetViewNear(float aValue);
	void __fastcall SetViewFar(float aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisCamera(Classes::TComponent* aOwner);
	__fastcall virtual ~TVisCamera(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Adjust(int aWidth, int aHeight) = 0 ;
	__property Visclass::TVisMatrix* Matrix = {read=FMatrix, write=FMatrix};
	
__published:
	__property float ViewNear = {read=FViewNear, write=SetViewNear};
	__property float ViewFar = {read=FViewFar, write=SetViewFar};
	__property Transformation ;
};


class DELPHICLASS TVisPerspectiveCamera;
class PASCALIMPLEMENTATION TVisPerspectiveCamera : public TVisCamera 
{
	typedef TVisCamera inherited;
	
private:
	float FViewAngle;
	void __fastcall WriteViewAngle(Classes::TWriter* Writer);
	void __fastcall SetViewAngle(float aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisPerspectiveCamera(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Adjust(int aWidth, int aHeight);
	
__published:
	__property float ViewAngle = {read=FViewAngle, write=SetViewAngle};
public:
	#pragma option push -w-inl
	/* TVisCamera.Destroy */ inline __fastcall virtual ~TVisPerspectiveCamera(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisOrthographicCamera;
class PASCALIMPLEMENTATION TVisOrthographicCamera : public TVisCamera 
{
	typedef TVisCamera inherited;
	
private:
	float FViewWidth;
	float FViewHeight;
	void __fastcall WriteViewWidth(Classes::TWriter* Writer);
	void __fastcall WriteViewHeight(Classes::TWriter* Writer);
	void __fastcall SetViewWidth(float aValue);
	void __fastcall SetViewHeight(float aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisOrthographicCamera(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Adjust(int aWidth, int aHeight);
	
__published:
	__property float ViewWidth = {read=FViewWidth, write=SetViewWidth};
	__property float ViewHeight = {read=FViewHeight, write=SetViewHeight};
public:
	#pragma option push -w-inl
	/* TVisCamera.Destroy */ inline __fastcall virtual ~TVisOrthographicCamera(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Viscam */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Viscam;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisCam
