// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisCanvasView.pas' rev: 5.00

#ifndef VisCanvasViewHPP
#define VisCanvasViewHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisTex.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Viscanvasview
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TVisBrush;
class PASCALIMPLEMENTATION TVisBrush : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	Graphics::TColor FColor;
	float FAlpha;
	void __fastcall SetAlpha(float Value);
	void __fastcall WriteAlpha(Classes::TWriter* Writer);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisBrush(void);
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property float Alpha = {read=FAlpha, write=SetAlpha};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TVisBrush(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisPen;
class PASCALIMPLEMENTATION TVisPen : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	Graphics::TColor FColor;
	float FAlpha;
	Visclass::TVisLineStipple FStyle;
	float FWidth;
	int FStippleShift;
	int FStippleScale;
	void __fastcall SetAlpha(float Value);
	void __fastcall WriteAlpha(Classes::TWriter* Writer);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisPen(void);
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property float Alpha = {read=FAlpha, write=SetAlpha};
	__property Visclass::TVisLineStipple Style = {read=FStyle, write=FStyle, nodefault};
	__property float Width = {read=FWidth, write=FWidth};
	__property int StippleShift = {read=FStippleShift, write=FStippleShift, nodefault};
	__property int StippleScale = {read=FStippleScale, write=FStippleScale, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TVisPen(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisFont;
class PASCALIMPLEMENTATION TVisFont : public Graphics::TFont 
{
	typedef Graphics::TFont inherited;
	
private:
	float FAlpha;
	int FListBase;
	void __fastcall SetAlpha(float Value);
	void __fastcall WriteAlpha(Classes::TWriter* Writer);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	DYNAMIC void __fastcall Changed(void);
	
public:
	__fastcall TVisFont(void);
	__fastcall virtual ~TVisFont(void);
	void __fastcall Reset(void);
	int __fastcall GetListBase(HDC aDC);
	
__published:
	__property float Alpha = {read=FAlpha, write=SetAlpha};
};


struct TPointDouble
{
	double X;
	double Y;
} ;

class DELPHICLASS TVisCanvas;
class DELPHICLASS TVisCanvasView;
class PASCALIMPLEMENTATION TVisCanvasView : public Visclass::TVisCustomView 
{
	typedef Visclass::TVisCustomView inherited;
	
private:
	TVisCanvas* FCanvas;
	
protected:
	__property TVisCanvas* Canvas = {read=FCanvas, write=FCanvas};
	virtual Vismath::TVisMathVector __fastcall WinFrom3D(const Vismath::TVisMathVector &Value) = 0 ;
	virtual HDC __fastcall GetHDC(void) = 0 ;
	virtual Vismath::TVisMathVector __fastcall GDITo3D(double X, double Y, double Depth);
	virtual int __fastcall GetNextID(System::TObject* Obj, int num) = 0 ;
	
public:
	__fastcall virtual TVisCanvasView(Classes::TComponent* aOwner);
	__fastcall virtual ~TVisCanvasView(void);
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TVisCanvasView(HWND ParentWindow) : Visclass::TVisCustomView(
		ParentWindow) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TVisCanvas : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TVisCanvasView* FOwner;
	Visclass::TVisTransparencyMode FTransparency;
	bool FAntialiasing;
	Windows::TPoint FPenPos;
	TVisPen* FPen;
	TVisBrush* FBrush;
	TVisFont* FFont;
	Visclass::TVisTransformation* FTransformation;
	Visclass::TVisColor* FColor;
	void __fastcall ExecuteTransparency(void);
	void __fastcall ExecutePenAttribs(bool used);
	void __fastcall ExecuteBrushAttribs(bool used);
	void __fastcall ExecuteAntialiasing(bool used);
	void __fastcall ExecuteFontAttribs(bool used);
	void __fastcall SetAttribs(void);
	void __fastcall ResetAttribs(void);
	void __fastcall DrawGLPoly(unsigned mode, const TPointDouble * points, const int points_Size, bool 
		Transform);
	void __fastcall DrawGLPoly4(unsigned mode, const TPointDouble * points, const int points_Size, const 
		TPointDouble * texcoords, const int texcoords_Size, bool Transform);
	
public:
	__fastcall TVisCanvas(TVisCanvasView* aOwner);
	__fastcall virtual ~TVisCanvas(void);
	virtual void __fastcall Ellipse(const Windows::TRect &Rect, double StartAngle, double SweepAngle, int 
		Detail)/* overload */;
	virtual void __fastcall Ellipse(int X1, int Y1, int X2, int Y2)/* overload */;
	virtual void __fastcall Ellipse(const Windows::TRect &Rect)/* overload */;
	void __fastcall MoveTo(int X, int Y);
	void __fastcall LineTo(int X, int Y);
	void __fastcall Polygon(const TPointDouble * points, const int points_Size);
	void __fastcall Rectangle(int X1, int Y1, int X2, int Y2)/* overload */;
	void __fastcall Rectangle(const Windows::TRect &Rect)/* overload */;
	void __fastcall FillRect(const Windows::TRect &Rect);
	void __fastcall FrameRect(const Windows::TRect &Rect);
	void __fastcall DrawFocusRect(const Windows::TRect &Rect);
	void __fastcall DrawTexture(int X, int Y, Classes::TComponent* Texture)/* overload */;
	void __fastcall DrawTexture(const Windows::TRect &Dest, Classes::TComponent* Texture, const Windows::TRect 
		&Source)/* overload */;
	void __fastcall TextOut(int X, int Y, const AnsiString Text);
//	void __fastcall TextOutA(int X, int Y, const AnsiString Text);
	__property Windows::TPoint PenPos = {read=FPenPos, write=FPenPos};
	__property Visclass::TVisTransparencyMode Transparency = {read=FTransparency, write=FTransparency, 
		default=0};
	__property bool Antialiasing = {read=FAntialiasing, write=FAntialiasing, default=0};
	__property TVisPen* Pen = {read=FPen, write=FPen};
	__property TVisBrush* Brush = {read=FBrush, write=FBrush};
	__property TVisFont* Font = {read=FFont, write=FFont};
	__property Visclass::TVisTransformation* Transformation = {read=FTransformation, write=FTransformation
		};
	__property Visclass::TVisColor* Color = {read=FColor, write=FColor};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Viscanvasview */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Viscanvasview;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisCanvasView
