// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisCntrl.pas' rev: 5.00

#ifndef VisCntrlHPP
#define VisCntrlHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisComp.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <VisCam.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Viscntrl
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TVisCntrlFlag { teMoveX, teMoveY, teMoveZ, teTurnX, teTurnY, teTurnZ };
#pragma option pop

typedef Set<TVisCntrlFlag, teMoveX, teTurnZ>  TVisCntrlFlags;

class DELPHICLASS TVisCustomController;
class PASCALIMPLEMENTATION TVisCustomController : public Viscomp::TVisComponent 
{
	typedef Viscomp::TVisComponent inherited;
	
private:
	Viscomp::TVisTransformed* FControlled;
	
protected:
	virtual void __fastcall SetControlled(const Viscomp::TVisTransformed* Value);
	
public:
	__fastcall virtual TVisCustomController(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall HandleKey(Word Key, Classes::TShiftState Shift);
	virtual bool __fastcall HandleMouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual bool __fastcall HandleMouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, 
		int X, int Y);
	virtual bool __fastcall HandleMouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int 
		X, int Y);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
__published:
	__property Viscomp::TVisTransformed* Controlled = {read=FControlled, write=SetControlled};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TVisCustomController(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisCarController;
class PASCALIMPLEMENTATION TVisCarController : public TVisCustomController 
{
	typedef TVisCustomController inherited;
	
private:
	float FCurrentSpeed;
	float FMaxSpeed;
	float FReverseSpeed;
	float FAcceleration;
	float FBraking;
	float FTurnAngle;
	void __fastcall WriteCurrentSpeed(Classes::TWriter* Writer);
	void __fastcall WriteMaxSpeed(Classes::TWriter* Writer);
	void __fastcall WriteReverseSpeed(Classes::TWriter* Writer);
	void __fastcall WriteAcceleration(Classes::TWriter* Writer);
	void __fastcall WriteBraking(Classes::TWriter* Writer);
	void __fastcall WriteTurnAngle(Classes::TWriter* Writer);
	void __fastcall SetCurrentSpeed(const float Value);
	void __fastcall SetEyeHeight(const float Value);
	float __fastcall GetEyeHeight(void);
	void __fastcall SetMaxSpeed(const float Value);
	void __fastcall SetReverseSpeed(const float Value);
	void __fastcall SetAcceleration(const float Value);
	void __fastcall SetBraking(const float Value);
	void __fastcall SetTurnAngle(const float Value);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall SetControlled(const Viscomp::TVisTransformed* Value);
	
public:
	__fastcall virtual TVisCarController(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall HandleKey(Word Key, Classes::TShiftState Shift);
	void __fastcall Move(void);
	void __fastcall Turn(const float Value);
	void __fastcall Accelerate(const float Value);
	void __fastcall Brake(const float Value);
	void __fastcall Stop(void);
	
__published:
	__property float CurrentSpeed = {read=FCurrentSpeed, write=SetCurrentSpeed};
	__property float EyeHeight = {read=GetEyeHeight, write=SetEyeHeight};
	__property float MaxSpeed = {read=FMaxSpeed, write=SetMaxSpeed};
	__property float ReverseSpeed = {read=FReverseSpeed, write=SetReverseSpeed};
	__property float Acceleration = {read=FAcceleration, write=SetAcceleration};
	__property float Braking = {read=FBraking, write=SetBraking};
	__property float TurnAngle = {read=FTurnAngle, write=SetTurnAngle};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TVisCarController(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisPersonController;
class PASCALIMPLEMENTATION TVisPersonController : public TVisCustomController 
{
	typedef TVisCustomController inherited;
	
private:
	float FStepLength;
	float FTurnAngle;
	void __fastcall WriteStepLength(Classes::TWriter* Writer);
	void __fastcall WriteTurnAngle(Classes::TWriter* Writer);
	void __fastcall SetEyeHeight(const float Value);
	float __fastcall GetEyeHeight(void);
	void __fastcall SetStepLength(const float Value);
	void __fastcall SetTurnAngle(const float Value);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall SetControlled(const Viscomp::TVisTransformed* Value);
	
public:
	__fastcall virtual TVisPersonController(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall HandleKey(Word Key, Classes::TShiftState Shift);
	void __fastcall Move(const float Value);
	void __fastcall Turn(const float Value);
	void __fastcall NodHead(const float Value);
	void __fastcall HeadForward(void);
	
__published:
	__property float EyeHeight = {read=GetEyeHeight, write=SetEyeHeight};
	__property float StepLength = {read=FStepLength, write=SetStepLength};
	__property float TurnAngle = {read=FTurnAngle, write=SetTurnAngle};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TVisPersonController(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisMouseController;
class PASCALIMPLEMENTATION TVisMouseController : public TVisCustomController 
{
	typedef TVisCustomController inherited;
	
private:
	int FoldX;
	int FoldY;
	int FMoveMode;
	int FTurnSensitivity;
	int FMoveSensitivity;
	TVisCntrlFlags FCntrlFlags;
	bool FSwitchButtons;
	void __fastcall SetTurnSensitivity(int value);
	void __fastcall SetMoveSensitivity(int value);
	Vismath::TVisMathVector __fastcall CalcVecX(double X, double Y, double Z);
	Vismath::TVisMathVector __fastcall CalcVecZ(double X, double Y, double Z);
	
protected:
	virtual void __fastcall SetControlled(const Viscomp::TVisTransformed* Value);
	
public:
	__fastcall virtual TVisMouseController(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall HandleMouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual bool __fastcall HandleMouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, 
		int X, int Y);
	virtual bool __fastcall HandleMouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int 
		X, int Y);
	void __fastcall TurnY(const float Value);
	void __fastcall MoveX(const float Value);
	void __fastcall MoveY(const float Value);
	void __fastcall MoveZ(const float Value);
	
__published:
	__property int TurnSensitivity = {read=FTurnSensitivity, write=SetTurnSensitivity, nodefault};
	__property int MoveSensitivity = {read=FMoveSensitivity, write=SetMoveSensitivity, nodefault};
	__property TVisCntrlFlags CntrlFlags = {read=FCntrlFlags, write=FCntrlFlags, default=63};
	__property bool SwitchButtons = {read=FSwitchButtons, write=FSwitchButtons, nodefault};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TVisMouseController(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TVisPresentationMode { pmStop, pmLeft, pmRight };
#pragma option pop

class DELPHICLASS TVisPresentationController;
class PASCALIMPLEMENTATION TVisPresentationController : public TVisCustomController 
{
	typedef TVisCustomController inherited;
	
private:
	float FTurnAngle;
	float FDistanceStep;
	TVisPresentationMode FMode;
	void __fastcall WriteTurnAngle(Classes::TWriter* Writer);
	void __fastcall WriteDistanceStep(Classes::TWriter* Writer);
	void __fastcall SetEyeHeight(const float Value);
	float __fastcall GetEyeHeight(void);
	void __fastcall SetDistance(const float Value);
	float __fastcall GetDistance(void);
	void __fastcall SetTurnAngle(const float Value);
	void __fastcall SetMode(const TVisPresentationMode Value);
	void __fastcall SetDistanceStep(const float Value);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall SetControlled(const Viscomp::TVisTransformed* Value);
	
public:
	__fastcall virtual TVisPresentationController(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual bool __fastcall HandleKey(Word Key, Classes::TShiftState Shift);
	void __fastcall Present(void);
	
__published:
	__property float EyeHeight = {read=GetEyeHeight, write=SetEyeHeight};
	__property float Distance = {read=GetDistance, write=SetDistance};
	__property float TurnAngle = {read=FTurnAngle, write=SetTurnAngle};
	__property float DistanceStep = {read=FDistanceStep, write=SetDistanceStep};
	__property TVisPresentationMode Mode = {read=FMode, write=SetMode, nodefault};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TVisPresentationController(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Viscntrl */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Viscntrl;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisCntrl
