// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisDxfImport.pas' rev: 5.00

#ifndef VisDxfImportHPP
#define VisDxfImportHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisMath.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <VisPoly.hpp>	// Pascal unit
#include <VisView.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <VisShape.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisObj.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Visdxfimport
{
//-- type declarations -------------------------------------------------------
typedef int IntArray[1];

class DELPHICLASS TVisDXFImport;
class PASCALIMPLEMENTATION TVisDXFImport : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	int Fcount;
	int maxcount;
	int *Fkey;
	char *Fstr;
	int Fstrsize;
	int Fmaxstrsize;
	Vismath::TVisMathVector Fxyz;
	Vismath::TVisMathVector Fmaxw;
	Vismath::TVisMathVector Fminw;
	int Fnr;
	int Ffrom;
	int fto;
	bool FHasMinMaxW;
	Visobj::TVisNode* FBlocknode;
	Visobj::TVisNode* FEntityNode;
	Classes::TStringList* mlist;
	void __fastcall addkey(int key);
	void __fastcall addstr(char * str, int length);
	void __fastcall setoptimalsize(void);
	void __fastcall cleararrays(void);
	char * __fastcall getvalue(int index);
	int __fastcall getkey(int index);
	int __fastcall getcount(void);
	int __fastcall findxyz(int akt, int count, int kotype);
	void __fastcall findscales(Visobj::TVisNode* aNode);
	void __fastcall parseline(Visobj::TVisNode* aNode);
	void __fastcall parsepolygon(Visobj::TVisNode* aNode);
	void __fastcall parsearc(Visobj::TVisNode* aNode);
	void __fastcall parse3dface(Visobj::TVisNode* aNode);
	void __fastcall parseinsert(Visobj::TVisNode* aNode);
	void __fastcall parseblock(Visobj::TVisNode* aNode);
	void __fastcall execute(Visobj::TVisNode* aNode);
	bool __fastcall FindnrbyValue(char * Value, int key, int first, int count);
	bool __fastcall findnr(int key, int first, int count);
	bool __fastcall findnrIn(int key);
	
protected:
	__property char * value[int index] = {read=getvalue};
	__property int key[int index] = {read=getkey};
	
public:
	__fastcall virtual TVisDXFImport(Classes::TComponent* owner);
	void __fastcall loadfromfile(AnsiString aFilename);
	void __fastcall setoptimalscale(void);
	void __fastcall Render(Visview::TVisView* aView);
	__property Classes::TStringList* NotParsed = {read=mlist};
	
__published:
	__property Visobj::TVisNode* EntityNode = {read=FEntityNode, write=FEntityNode};
	__property Visobj::TVisNode* BlockNode = {read=FBlocknode, write=FBlocknode};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TVisDXFImport(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint idStart = 0x0;
static const Shortint idText = 0x1;
static const Shortint idName = 0x2;
static const Shortint idObjRefHex = 0x5;
static const Shortint idNameLineType = 0x6;
static const Shortint idNameTextStyle = 0x7;
static const Shortint idNameLayer = 0x8;
static const Shortint idVariable = 0x9;
static const Shortint idX1 = 0xa;
static const Shortint idX2 = 0xb;
static const Shortint idX3 = 0xc;
static const Shortint idY1 = 0x14;
static const Shortint idY2 = 0x15;
static const Shortint idY3 = 0x16;
static const Shortint iDZ1 = 0x1e;
static const Shortint idZ2 = 0x1f;
static const Shortint idZ3 = 0x20;
static const Shortint idElevation = 0x26;
static const Shortint idObjHeight = 0x27;
static const Shortint idRepeat = 0x31;
static const Shortint idColor = 0x3e;
static const Shortint idEntitiesFolow = 0x42;
static const Shortint idPaper = 0x43;
static const Word idComment = 0x3e7;
static const Byte maxstringlenght = 0xff;
#define stENDSEC "ENDSEC"
#define stLINE "LINE"
#define stPOLYLINE "POLYLINE"
#define stVERTEX "VERTEX"
#define stSEQEND "SEQEND"
#define stARC "ARC"
#define stCIRCLE "CIRCLE"
#define st3DFACE "3DFACE"
#define stINSERT "INSERT"
#define stBLOCKS "BLOCKS"
#define stBLOCK "BLOCK"
#define stENDBLK "ENDBLK"
#define stENTITIES "ENTITIES"
extern PACKAGE int __fastcall getunifiedId(void);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Visdxfimport */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Visdxfimport;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisDxfImport
