// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisExchange.pas' rev: 5.00

#ifndef VisExchangeHPP
#define VisExchangeHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <XMLParser.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Visexchange
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TVisExchangeState { stReady, stSaveNode, stSaveObj, stVISGLSave, stVISGLLoad, stStartLoad, stEndSave, 
	stOBJLoad };
#pragma option pop

typedef Set<Byte, 0, 255>  TVisSet;

typedef TVisSet *PVisSet;

typedef TXMLTag TVisXMLTag;
;

typedef TXMLTag TVisGETTag;
;

class DELPHICLASS TVisExchange;
class PASCALIMPLEMENTATION TVisExchange : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TMemoryStream* FList;
	bool FNodefaultValues;
	int Fdecimals;
	Classes::TList* Fstack;
	int Fstint;
	Classes::TStringList* FParams;
	Xmlparser::TXMLParser* FXMLParser;
	bool FParamNewLine;
	TVisExchangeState Fstate;
	Xmlparser::TXMLTag* rootTag;
	AnsiString FFileName;
	int FFileNr;
	int FObjSteps;
	int FObjCount;
	Xmlparser::TXMLProgressEvent FOnSProgress;
	AnsiString FFileDescription;
	void __fastcall InitSave(void);
	void __fastcall EndSave(void);
	int __fastcall GetDepth(void);
	Xmlparser::TXMLTag* __fastcall GetAktTag(void);
	void __fastcall popstack(void);
	void __fastcall pushstack(Xmlparser::TXMLTag* value);
	Xmlparser::TXMLTag* __fastcall lastbefore(void);
	Xmlparser::TXMLTag* __fastcall getnew(void);
	virtual void __fastcall addparam(AnsiString Name, Classes::TComponent* Value)/* overload */;
	virtual void __fastcall addparam(AnsiString Name, const Variant &Value, double aDefault)/* overload */
		;
	int __fastcall getenumv(AnsiString aValue, const AnsiString * aEnum, const int aEnum_Size);
	void __fastcall atXMLTag(Xmlparser::TXMLTag* &Tag);
	void __fastcall atXMLEndTag(Xmlparser::TXMLTag* &Tag);
	
public:
	__fastcall virtual TVisExchange(Classes::TComponent* aOwner);
	__fastcall virtual ~TVisExchange(void);
	virtual AnsiString __fastcall toStr(Classes::TComponent* Value)/* overload */;
	virtual AnsiString __fastcall toStr(const Vismath::TVisMathVector &Value, const Vismath::TVisMathVector 
		&aDefault)/* overload */;
	virtual AnsiString __fastcall toStr(const Variant &Value, double aDefault)/* overload */;
	AnsiString __fastcall int2hex(int Value);
	int __fastcall hex2int(AnsiString Value);
	virtual void __fastcall addtag(AnsiString Name, int Value, const AnsiString * aEnum, const int aEnum_Size
		)/* overload */;
	virtual void __fastcall addtag(AnsiString Name, Classes::TComponent* Value, Classes::TComponent* aDefault
		)/* overload */;
	virtual void __fastcall addtag(AnsiString Name, const Vismath::TVisMathVector &Value, const Vismath::TVisMathVector 
		&aDefault)/* overload */;
	virtual void __fastcall addtag(AnsiString Name, const Variant &Value, const Variant &aDefault)/* overload */
		;
	virtual void __fastcall addtag(AnsiString Name, PVisSet Value, const AnsiString * aEnum, const int 
		aEnum_Size)/* overload */;
	void __fastcall addvalue(AnsiString Value);
	int __fastcall StartTag(AnsiString Name);
	int __fastcall EndTag(void);
	void __fastcall SavetoFile(System::TObject* aObj);
	void __fastcall LoadfromFile(System::TObject* aObj);
	virtual Vismath::TVisMathVector __fastcall Strto(AnsiString aValue, const Vismath::TVisMathVector &
		aDefault)/* overload */;
	virtual Variant __fastcall Strto(AnsiString Value, const Variant &aDefault)/* overload */;
	__property Xmlparser::TXMLTag* akttag = {read=GetAktTag};
	__property int depth = {read=GetDepth, nodefault};
	void __fastcall clear(void);
	void __fastcall SaveObj(Classes::TComponent* aObj);
	__property Classes::TStringList* Params = {read=FParams, write=FParams};
	__property Xmlparser::TXMLParser* XMLParser = {read=FXMLParser};
	virtual Variant __fastcall getvalue(AnsiString aName, const Variant &aDefault)/* overload */;
	virtual Vismath::TVisMathVector __fastcall getvalue(AnsiString aName, const Vismath::TVisMathVector 
		&aDefault)/* overload */;
	int __fastcall getenums(AnsiString aName, const AnsiString * aEnum, const int aEnum_Size);
	virtual void __fastcall getvalue(AnsiString aName, PVisSet aSet, const AnsiString * aEnum, const int 
		aEnum_Size)/* overload */;
	void __fastcall ObjStep(void);
	AnsiString __fastcall GetAFilename(AnsiString ext);
	__property TVisExchangeState State = {read=Fstate, nodefault};
	
__published:
	__property bool ParamNewLine = {read=FParamNewLine, write=FParamNewLine, nodefault};
	__property bool NoDefaultValues = {read=FNodefaultValues, write=FNodefaultValues, nodefault};
	__property int Decimals = {read=Fdecimals, write=Fdecimals, nodefault};
	__property Xmlparser::TXMLProgressEvent OnSProgress = {read=FOnSProgress, write=FOnSProgress};
	__property AnsiString FileDescription = {read=FFileDescription, write=FFileDescription};
	__property AnsiString FileName = {read=FFileName, write=FFileName};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Visexchange */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Visexchange;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisExchange
