// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisMath.pas' rev: 5.00

#ifndef VisMathHPP
#define VisMathHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vismath
{
//-- type declarations -------------------------------------------------------
struct TVisMathVector
{
	
	union
	{
		struct 
		{
			double a[3];
			
		};
		struct 
		{
			double x;
			double y;
			double z;
			
		};
		
	};
} ;

struct TVisMathVector4d
{
	
	union
	{
		struct 
		{
			TVisMathVector vec3;
			
		};
		struct 
		{
			double col[4];
			
		};
		struct 
		{
			double a[4];
			
		};
		struct 
		{
			double x;
			double y;
			double z;
			double w;
			
		};
		
	};
} ;

struct TVisMathMatrix
{
	
	union
	{
		struct 
		{
			double a[16];
			
		};
		struct 
		{
			TVisMathVector4d row[4];
			
		};
		struct 
		{
			TVisMathVector4d x;
			TVisMathVector4d y;
			TVisMathVector4d z;
			TVisMathVector4d w;
			
		};
		
	};
} ;

struct TVisMathPlane
{
	
	union
	{
		struct 
		{
			TVisMathVector n;
			
		};
		struct 
		{
			TVisMathVector4d v;
			
		};
		struct 
		{
			double x;
			double y;
			double z;
			double w;
			
		};
		
	};
} ;

typedef TVisMathVector  TVisMathPoint;

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TVisMathVector ZEROVEC;
extern PACKAGE TVisMathVector __fastcall ToVec(double x, double y, double z);
extern PACKAGE TVisMathVector4d __fastcall ToVec4D(double x, double y, double z, double w);
extern PACKAGE void __fastcall VisMathVectorAddition(const TVisMathVector &A, const TVisMathVector &
	B, TVisMathVector &C);
extern PACKAGE void __fastcall VisMathScalarProduct(const TVisMathVector &A, double Scalar, TVisMathVector 
	&C);
extern PACKAGE void __fastcall VisMathCrossProduct(const TVisMathVector &A, const TVisMathVector &B, 
	TVisMathVector &C);
extern PACKAGE double __fastcall VisMathDotProduct(const TVisMathVector &A, const TVisMathVector &B)
	;
extern PACKAGE void __fastcall VisMathNormalVector(const TVisMathVector &P1, const TVisMathVector &P2
	, const TVisMathVector &P3, bool Normalize, TVisMathVector &N);
extern PACKAGE void __fastcall VisMathNormalize(TVisMathVector &A);
extern PACKAGE double __fastcall VisMathVectorLength(const TVisMathVector &A);
extern PACKAGE double __fastcall VisMathVectorDist(const TVisMathVector &A, const TVisMathVector &B)
	;
extern PACKAGE TVisMathVector __fastcall VisMathVectorInterpolate(const TVisMathVector &A, const TVisMathVector 
	&B);
extern PACKAGE TVisMathPlane __fastcall VisMathPlanefromPoints(const TVisMathVector &P1, const TVisMathVector 
	&P2, const TVisMathVector &P3);

}	/* namespace Vismath */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vismath;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisMath
