// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisPointSet.pas' rev: 5.00

#ifndef VisPointSetHPP
#define VisPointSetHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisComp.hpp>	// Pascal unit
#include <VisPrimClasses.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisExchange.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisPrimitiveObj.hpp>	// Pascal unit
#include <VisShape.hpp>	// Pascal unit
#include <VisObj.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vispointset
{
//-- type declarations -------------------------------------------------------
struct TVisPSetHeader
{
	char ftype[4];
	int filelen;
	int headlen;
	int version;
	int minx;
	int deltax;
	int miny;
	int deltay;
	int minz;
	int deltaz;
	int points;
	char ptype[4];
} ;

struct Tint3
{
	int x;
	int y;
	int z;
} ;

typedef double TaDouble[1];

typedef double *TpaDouble;

typedef int TaInteger[1];

typedef int *TpaInteger;

#pragma option push -b-
enum TVisPSetMode { mdArray, mdOnlyZ, mdPoints };
#pragma option pop

#pragma option push -b-
enum TVisScaleMode { smNoScale, smProportional, smEqualize };
#pragma option pop

typedef AnsiString VisPointSet__1[3];

typedef AnsiString VisPointSet__2[3];

class DELPHICLASS TVisPointSet;
class PASCALIMPLEMENTATION TVisPointSet : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	TVisPSetMode FMode;
	int FSizeX;
	int FSizeY;
	int FGridSizeX;
	int FGridSizeY;
	Vismath::TVisMathVector FShift;
	Vismath::TVisMathVector FScale;
	Visclass::TVisVector* FScaleDims;
	bool FInterpolate;
	TVisScaleMode FScaleMode;
	void __fastcall InitArray(void * p, int SizeX, int SizeY, int ElType, TVisPSetMode mode);
	void __fastcall SetSize(int index, int value);
	void __fastcall SetMode(TVisPSetMode aMode);
	Vismath::TVisMathVector __fastcall GetData2d(int x, int y);
	void __fastcall SetData2d(int x, int y, const Vismath::TVisMathVector &value);
	Vismath::TVisMathVector __fastcall GetData1d(int n);
	void __fastcall SetData1d(int n, const Vismath::TVisMathVector &value);
	void __fastcall SetScaleDims(Visclass::TVisVector* value);
	
public:
	__fastcall virtual TVisPointSet(Classes::TComponent* aOwner);
	__fastcall virtual ~TVisPointSet(void);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	void __fastcall SetArray(TpaDouble Data, int SizeX, int SizeY, TVisPSetMode mode);
	void __fastcall SetIntArray(TpaInteger Data, int SizeX, int SizeY, TVisPSetMode mode);
	bool __fastcall LoadfromFile(const AnsiString filename);
	void __fastcall SavetoFile(const AnsiString filename);
	void __fastcall CalcGrid(void);
	void __fastcall CalcTriangulation(void);
	void __fastcall ScaleData(void);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	virtual Classes::TPersistent* __fastcall ReadComp(Visexchange::TVisExchange* exchange, Xmlparser::TXMLTag* 
		aTag);
	__property Vismath::TVisMathVector Data2D[int x][int y] = {read=GetData2d, write=SetData2d};
	__property Vismath::TVisMathVector Data1D[int n] = {read=GetData1d, write=SetData1d};
	
__published:
	__property TextureFlags ;
	__property bool Interpolate = {read=FInterpolate, write=FInterpolate, nodefault};
	__property TVisScaleMode ScaleMode = {read=FScaleMode, write=FScaleMode, nodefault};
	__property int GridSizeX = {read=FGridSizeX, write=SetSize, index=0, default=10};
	__property int GridSizeY = {read=FGridSizeY, write=SetSize, index=1, default=10};
	__property TVisPSetMode Mode = {read=FMode, write=SetMode, nodefault};
	__property Visclass::TVisVector* ScaleDims = {read=FScaleDims, write=SetScaleDims};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE AnsiString TVisPSetModeStr[3];
extern PACKAGE AnsiString TVisScaleModeStr[3];
#define ftGeos "GEOS"
#define ptInt4 "INT4"
#define ptDouble8 "DBL8"
static const Shortint veAKT = 0x1;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Vispointset */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vispointset;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisPointSet
