// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisPrimClasses.pas' rev: 5.00

#ifndef VisPrimClassesHPP
#define VisPrimClassesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Windows.hpp>	// Pascal unit
#include <VisTex.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisExchange.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Visprimclasses
{
//-- type declarations -------------------------------------------------------
typedef Vismath::TVisMathVector  Tpoint3d;

typedef float TColor4f[4];

typedef Vismath::TVisMathVector TVisArray3d[1];

typedef Vismath::TVisMathVector *PVisArray3d;

typedef float TVisArray4f[1][4];

typedef float *PVisArray4f;

typedef int TVisArray1i[2];

typedef int *PVisArray1i;

typedef Byte TVisArray1b[1];

typedef Byte *PVisArray1b;

#pragma option push -b-
enum TVisArray { daVertex, daNormal, daTexture, daColor, daEdgeFlag, daFlag };
#pragma option pop

typedef Set<TVisArray, daVertex, daFlag>  TVisArrays;

struct T2DIntPoint
{
	int x;
	int y;
} ;

typedef T2DIntPoint T2DIntPointArr[1];

typedef T2DIntPoint *P2DIntPointArr;

class DELPHICLASS TVisPointItem;
class PASCALIMPLEMENTATION TVisPointItem : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	Visclass::TVisVector* FPoint;
	Visclass::TVisNormal* FNormal;
	Visclass::TVisVector* FTexture;
	Visclass::TVisColor* FColor;
	int FFlags;
	bool FEnabled;
	void __fastcall SetPoint(const Visclass::TVisVector* Value);
	void __fastcall SetNormal(const Visclass::TVisNormal* Value);
	void __fastcall SetTexture(const Visclass::TVisVector* Value);
	void __fastcall SetColor(const Visclass::TVisColor* Value);
	
public:
	__fastcall virtual TVisPointItem(void);
	__fastcall virtual ~TVisPointItem(void);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	__property Visclass::TVisVector* Point = {read=FPoint, write=SetPoint};
	__property Visclass::TVisNormal* Normal = {read=FNormal, write=SetNormal};
	__property Visclass::TVisVector* Texture = {read=FTexture, write=SetTexture};
	__property Visclass::TVisColor* Color = {read=FColor, write=SetColor};
	__property bool Enabled = {read=FEnabled, write=FEnabled, nodefault};
	__property int Flags = {read=FFlags, write=FFlags, nodefault};
};


class DELPHICLASS TVisPrimitivePoints;
class PASCALIMPLEMENTATION TVisPrimitivePoints : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	Vismath::TVisMathVector *FVertexArray;
	Vismath::TVisMathVector *FNormalArray;
	Vismath::TVisMathVector *FTextureArray;
	float *FColorArray;
	Byte *FEdgeFlagArray;
	Byte *FFlagArray;
	int FSize;
	int FCount;
	TVisArrays FDefineArrays;
	TVisArrays FDrawArrays;
	void __fastcall SetSize(int aSize);
	void __fastcall SetCount(int aCount);
	double __fastcall GetValues(int Nr, int XYZ, int index);
	void __fastcall SetValues(int Nr, int XYZ, int index, double value);
	Vismath::TVisMathVector __fastcall GetVector(int Nr, int index);
	void __fastcall SetVector(int Nr, int index, const Vismath::TVisMathVector &value);
	Byte __fastcall GetEdgeFlag(int Nr);
	void __fastcall SetEdgeFlag(int Nr, Byte value);
	void __fastcall SetDefineArrays(TVisArrays value);
	void __fastcall SetFlag(int Nr, int index, bool Value);
	bool __fastcall GetFlag(int Nr, int index);
	
public:
	__fastcall virtual TVisPrimitivePoints(void);
	__fastcall virtual ~TVisPrimitivePoints(void);
	void __fastcall BeforeRender(Visclass::TVisCustomView* aView);
	void __fastcall AfterRender(Visclass::TVisCustomView* aView);
	virtual int __fastcall Add(double x, double y, double z)/* overload */;
	virtual int __fastcall Add(const Vismath::TVisMathVector &Vertex, const Vismath::TVisMathVector &Normal
		, const Vismath::TVisMathVector &Texture)/* overload */;
	virtual int __fastcall Add(TVisPointItem* value)/* overload */;
	virtual int __fastcall Add(TVisPrimitivePoints* value)/* overload */;
	void __fastcall Delete(int Index, int aCount);
	void __fastcall GetPoint(int index, TVisPointItem* &value);
	void __fastcall SetPoint(int index, TVisPointItem* value);
	void __fastcall LiftPoint(int index, double value);
	void __fastcall ScalePoints(double scaleX, double scaleY, double scaleZ);
	void __fastcall MovePoints(double moveX, double moveY, double moveZ);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property int Size = {read=FSize, write=SetSize, nodefault};
	__property int Count = {read=FCount, write=SetCount, nodefault};
	__property TVisArrays DefineArrays = {read=FDefineArrays, write=SetDefineArrays, nodefault};
	__property TVisArrays DrawArrays = {read=FDrawArrays, write=FDrawArrays, nodefault};
	__property Vismath::TVisMathVector PointVec[int Nr] = {read=GetVector, write=SetVector, index=0/*, 
		default*/};
	__property Vismath::TVisMathVector NormalVec[int Nr] = {read=GetVector, write=SetVector, index=1};
	__property Vismath::TVisMathVector TextureVec[int Nr] = {read=GetVector, write=SetVector, index=2};
		
	__property double Point[int Nr][int XYZ] = {read=GetValues, write=SetValues, index=0};
	__property double Normal[int Nr][int XYZ] = {read=GetValues, write=SetValues, index=1};
	__property double Texture[int Nr][int XYZ] = {read=GetValues, write=SetValues, index=2};
	__property double Color[int Nr][int XYZ] = {read=GetValues, write=SetValues, index=3};
	__property Byte EdgeFlag[int Nr] = {read=GetEdgeFlag, write=SetEdgeFlag};
	__property bool ShareLight[int Nr] = {read=GetFlag, write=SetFlag, index=0};
	__property bool SharePosition[int Nr] = {read=GetFlag, write=SetFlag, index=1};
	__property bool CloseFlag[int Nr] = {read=GetFlag, write=SetFlag, index=2};
};


class DELPHICLASS TVisPrimitiveArray;
class PASCALIMPLEMENTATION TVisPrimitiveArray : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	int FCount;
	int FSize;
	int Ftype;
	bool FEnabled;
	Vistex::TVisTexture* FTexture;
	bool FTextured;
	int *FIndices;
	void __fastcall SetType(int aValue);
	void __fastcall SwitchToTriangles(void);
	void __fastcall SwitchToQuads(void);
	void __fastcall SetSize(int aSize);
	void __fastcall SetCount(int aCount);
	void __fastcall SetIndices(int index, int value);
	int __fastcall GetIndices(int index);
	
public:
	__fastcall TVisPrimitiveArray(int aType);
	__fastcall virtual ~TVisPrimitiveArray(void);
	void __fastcall AddIndex(int index);
	void __fastcall Add(TVisPrimitiveArray* Value, int offset);
	void __fastcall Insert(int position, int index);
	void __fastcall Delete(int index, int aCount);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Invert(void);
	void __fastcall ProceedDirectRendering(void);
	__property int Indices[int index] = {read=GetIndices, write=SetIndices};
	__property int Size = {read=FSize, write=SetSize, nodefault};
	__property int Count = {read=FCount, write=SetCount, nodefault};
	__property bool Enabled = {read=FEnabled, write=FEnabled, nodefault};
	__property int PrimitiveType = {read=Ftype, write=SetType, nodefault};
	__property Vistex::TVisTexture* Texture = {read=FTexture, write=FTexture};
	__property bool Textured = {read=FTextured, write=FTextured, nodefault};
};


class DELPHICLASS TVisTextureFlags;
class PASCALIMPLEMENTATION TVisTextureFlags : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	Visclass::TVisTextureMode FTexMode;
	double FShiftY;
	double FShiftX;
	double FScaleX;
	double FScaleY;
	Visclass::TVisVector* FParamVec;
	void __fastcall SetParamVec(Visclass::TVisVector* value);
	
public:
	__fastcall virtual TVisTextureFlags(void);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual Classes::TPersistent* __fastcall ReadComp(Visexchange::TVisExchange* exchange, Xmlparser::TXMLTag* 
		aTag);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Visclass::TVisTextureMode Mode = {read=FTexMode, write=FTexMode, nodefault};
	__property double ShiftX = {read=FShiftX, write=FShiftX};
	__property double ShiftY = {read=FShiftY, write=FShiftY};
	__property double ScaleX = {read=FScaleX, write=FScaleX};
	__property double ScaleY = {read=FScaleY, write=FScaleY};
	__property Visclass::TVisVector* ParamVector = {read=FParamVec, write=SetParamVec};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TVisTextureFlags(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Visprimclasses */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Visprimclasses;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisPrimClasses
