// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisShape.pas' rev: 5.00

#ifndef VisShapeHPP
#define VisShapeHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisComp.hpp>	// Pascal unit
#include <VisObj.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisPrimClasses.hpp>	// Pascal unit
#include <VisExchange.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisPrimitiveObj.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Visshape
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSphereMode { smGlobal, smRegular };
#pragma option pop

typedef AnsiString VisShape__1[2];

class DELPHICLASS TVisSphere;
class PASCALIMPLEMENTATION TVisSphere : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	double FRadius;
	int FSlices;
	int FStacks;
	TSphereMode FMode;
	void __fastcall WriteRadius(Classes::TWriter* Writer);
	void __fastcall SetRadius(double aValue);
	void __fastcall SetSlices(int aValue);
	void __fastcall SetStacks(int aValue);
	void __fastcall SetMode(TSphereMode aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisSphere(Classes::TComponent* aOwner);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	
__published:
	__property int Slices = {read=FSlices, write=SetSlices, nodefault};
	__property int Stacks = {read=FStacks, write=SetStacks, nodefault};
	__property double Radius = {read=FRadius, write=SetRadius};
	__property TSphereMode Mode = {read=FMode, write=SetMode, nodefault};
public:
	#pragma option push -w-inl
	/* TVisPrimitiveObj.Destroy */ inline __fastcall virtual ~TVisSphere(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisCylinder;
class PASCALIMPLEMENTATION TVisCylinder : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	double FBaseRadius;
	double FTopRadius;
	double FHeight;
	bool FClosed;
	int FSlices;
	int FStacks;
	void __fastcall WriteBaseRadius(Classes::TWriter* Writer);
	void __fastcall WriteTopRadius(Classes::TWriter* Writer);
	void __fastcall WriteHeight(Classes::TWriter* Writer);
	void __fastcall SetHeight(double aValue);
	void __fastcall SetSlices(int aValue);
	void __fastcall SetStacks(int aValue);
	void __fastcall SetClosed(bool aValue);
	void __fastcall SetBaseRadius(double aValue);
	void __fastcall SetTopRadius(double aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisCylinder(Classes::TComponent* aOwner);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	
__published:
	__property double BaseRadius = {read=FBaseRadius, write=SetBaseRadius};
	__property double TopRadius = {read=FTopRadius, write=SetTopRadius};
	__property double Height = {read=FHeight, write=SetHeight};
	__property bool Closed = {read=FClosed, write=SetClosed, nodefault};
	__property int Slices = {read=FSlices, write=SetSlices, nodefault};
	__property int Stacks = {read=FStacks, write=SetStacks, nodefault};
public:
	#pragma option push -w-inl
	/* TVisPrimitiveObj.Destroy */ inline __fastcall virtual ~TVisCylinder(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisDisc;
class PASCALIMPLEMENTATION TVisDisc : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	double FOuterRadius;
	double FInnerRadius;
	double FStartAngle;
	double FSweepAngle;
	int FSlices;
	int FStacks;
	void __fastcall WriteOuterRadius(Classes::TWriter* Writer);
	void __fastcall WriteInnerRadius(Classes::TWriter* Writer);
	void __fastcall WriteStartAngle(Classes::TWriter* Writer);
	void __fastcall WriteSweepAngle(Classes::TWriter* Writer);
	void __fastcall SetSlices(int aValue);
	void __fastcall SetStacks(int aValue);
	void __fastcall SetSweepAngle(double aValue);
	void __fastcall SetStartAngle(double aValue);
	void __fastcall SetInnerRadius(double aValue);
	void __fastcall SetOuterRadius(double aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisDisc(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	
__published:
	__property double OuterRadius = {read=FOuterRadius, write=SetOuterRadius};
	__property double InnerRadius = {read=FInnerRadius, write=SetInnerRadius};
	__property double StartAngle = {read=FStartAngle, write=SetStartAngle};
	__property double SweepAngle = {read=FSweepAngle, write=SetSweepAngle};
	__property int Slices = {read=FSlices, write=SetSlices, nodefault};
	__property int Stacks = {read=FStacks, write=SetStacks, nodefault};
public:
	#pragma option push -w-inl
	/* TVisPrimitiveObj.Destroy */ inline __fastcall virtual ~TVisDisc(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisTorus;
class PASCALIMPLEMENTATION TVisTorus : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	double FRadius;
	double FThickness;
	int FSlices;
	int FStacks;
	void __fastcall WriteRadius(Classes::TWriter* Writer);
	void __fastcall SetRadius(double aValue);
	void __fastcall WriteThickness(Classes::TWriter* Writer);
	void __fastcall SetThickness(double aValue);
	void __fastcall SetSlices(int aValue);
	void __fastcall SetStacks(int aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisTorus(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	
__published:
	__property double Radius = {read=FRadius, write=SetRadius};
	__property double Thickness = {read=FThickness, write=SetThickness};
	__property int Slices = {read=FSlices, write=SetSlices, nodefault};
	__property int Stacks = {read=FStacks, write=SetStacks, nodefault};
public:
	#pragma option push -w-inl
	/* TVisPrimitiveObj.Destroy */ inline __fastcall virtual ~TVisTorus(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TBoxFace { bfFront, bfLeft, bfRight, bfBack, bfTop, bfBottom };
#pragma option pop

typedef Set<TBoxFace, bfFront, bfBottom>  TBoxFaces;

typedef AnsiString VisShape__6[6];

class DELPHICLASS TVisBox;
class PASCALIMPLEMENTATION TVisBox : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	float FWidth;
	float FHeight;
	float FDepth;
	TBoxFaces FFaces;
	int FDetailX;
	int FDetailY;
	int FDetailZ;
	void __fastcall WriteWidth(Classes::TWriter* Writer);
	void __fastcall WriteHeight(Classes::TWriter* Writer);
	void __fastcall WriteDepth(Classes::TWriter* Writer);
	void __fastcall SetDepth(float aValue);
	void __fastcall SetHeight(float aValue);
	void __fastcall SetWidth(float aValue);
	void __fastcall SetFaces(TBoxFaces aValue);
	void __fastcall SetDetail(int index, int aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisBox(Classes::TComponent* aOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	
__published:
	__property float Width = {read=FWidth, write=SetWidth};
	__property float Height = {read=FHeight, write=SetHeight};
	__property float Depth = {read=FDepth, write=SetDepth};
	__property TBoxFaces Faces = {read=FFaces, write=SetFaces, nodefault};
	__property int DetailX = {read=FDetailX, write=SetDetail, index=0, nodefault};
	__property int DetailY = {read=FDetailY, write=SetDetail, index=1, nodefault};
	__property int DetailZ = {read=FDetailZ, write=SetDetail, index=2, nodefault};
public:
	#pragma option push -w-inl
	/* TVisPrimitiveObj.Destroy */ inline __fastcall virtual ~TVisBox(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE AnsiString TSphereModeStr[2];
extern PACKAGE AnsiString TBoxFaceStr[6];
extern PACKAGE void __fastcall Register(void);

}	/* namespace Visshape */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Visshape;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisShape
