// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisTube.pas' rev: 5.00

#ifndef VisTubeHPP
#define VisTubeHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisComp.hpp>	// Pascal unit
#include <VisPrimitiveObj.hpp>	// Pascal unit
#include <VisPrimClasses.hpp>	// Pascal unit
#include <VisExchange.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisView.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisObj.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vistube
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TRadChange { rcLinear, rcSmooth, rcStartSmooth, rcEndSmooth };
#pragma option pop

#pragma option push -b-
enum TVisTubeSectionType { stLine, stBend };
#pragma option pop

typedef AnsiString VisTube__1[2];

typedef AnsiString VisTube__2[4];

class DELPHICLASS TVisCustomTubeSegment;
class PASCALIMPLEMENTATION TVisCustomTubeSegment : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	Visclass::TVisVector* FNewVec;
	Visclass::TVisVector* Fvecx;
	Visclass::TVisVector* Fvecy;
	int FSecNum;
	
protected:
	virtual Vismath::TVisMathVector __fastcall GetSegmentPoint(int Index, int Slices);
	
public:
	__fastcall virtual TVisCustomTubeSegment(void);
	__fastcall virtual ~TVisCustomTubeSegment(void);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual Classes::TPersistent* __fastcall ReadComp(Visexchange::TVisExchange* exchange, Xmlparser::TXMLTag* 
		aTag);
	__property Visclass::TVisVector* VecX = {read=Fvecx, write=Fvecx};
	__property Visclass::TVisVector* VecY = {read=Fvecy, write=Fvecy};
	__property Visclass::TVisVector* StartPos = {read=FNewVec, write=FNewVec};
};


class DELPHICLASS TVisTubeSegment;
class PASCALIMPLEMENTATION TVisTubeSegment : public TVisCustomTubeSegment 
{
	typedef TVisCustomTubeSegment inherited;
	
private:
	double FRadius;
	
protected:
	virtual Vismath::TVisMathVector __fastcall GetSegmentPoint(int Index, int Slices);
	
public:
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	__property double Radius = {read=FRadius, write=FRadius};
public:
	#pragma option push -w-inl
	/* TVisCustomTubeSegment.Create */ inline __fastcall virtual TVisTubeSegment(void) : TVisCustomTubeSegment(
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TVisCustomTubeSegment.Destroy */ inline __fastcall virtual ~TVisTubeSegment(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisTubeSection;
class PASCALIMPLEMENTATION TVisTubeSection : public Visclass::TVisProperty 
{
	typedef Visclass::TVisProperty inherited;
	
private:
	bool Fupdate;
	TVisTubeSectionType FSectionType;
	Vismath::TVisMathVector FEndPos;
	double Fradius;
	TRadChange FRadChange;
	int Fstacks;
	int FFirstSeg;
	double FEndAngleX;
	double FEndAngleY;
	Vismath::TVisMathVector FStartPos;
	void __fastcall SetEndPos(const Vismath::TVisMathVector &value);
	void __fastcall SetRadius(double value);
	void __fastcall SetRadChange(TRadChange value);
	void __fastcall SetStacks(int value);
	void __fastcall SetEndAngleX(double value);
	void __fastcall SetEndAngleY(double value);
	
public:
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	void __fastcall SetValues(double dx, double dy, double dz, double aradius, int astacks, TRadChange 
		aRadChange, TVisTubeSectionType aSectionType, double aEndAngleX, double aEndAngleY);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TVisTubeSectionType SectionType = {read=FSectionType, nodefault};
	__property Vismath::TVisMathVector EndPos = {read=FEndPos, write=SetEndPos};
	__property double Radius = {read=Fradius, write=SetRadius};
	__property TRadChange RadChange = {read=FRadChange, write=SetRadChange, nodefault};
	__property int Stacks = {read=Fstacks, write=SetStacks, nodefault};
	__property double EndAngleX = {read=FEndAngleX, write=SetEndAngleX};
	__property double EndAngleY = {read=FEndAngleY, write=SetEndAngleY};
public:
	#pragma option push -w-inl
	/* TVisProperty.Create */ inline __fastcall virtual TVisTubeSection(void) : Visclass::TVisProperty(
		) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TVisTubeSection(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisTube;
class PASCALIMPLEMENTATION TVisTube : public Visprimitiveobj::TVisPrimitiveObj 
{
	typedef Visprimitiveobj::TVisPrimitiveObj inherited;
	
private:
	Classes::TList* FSections;
	Classes::TList* FSegments;
	int FSlices;
	double __fastcall GetRad(double rstart, double rend, int stack, int stackcount, TRadChange mode);
	TVisTubeSection* __fastcall GetSection(int index);
	void __fastcall SetSection(int index, TVisTubeSection* ASection);
	void __fastcall NewSection(int index, TVisTubeSection* ASection);
	void __fastcall UpdateSections(int Secindex, int Segmentindex);
	int __fastcall GetSegCount(void);
	void __fastcall ConstructSection(int SecNum);
	TVisTubeSegment* __fastcall GetStartSegment(void);
	void __fastcall SetStartSegment(TVisTubeSegment* value);
	void __fastcall SetSlices(int aValue);
	HIDESBASE Vismath::TVisMathVector __fastcall CalcTexture(const Vismath::TVisMathVector &point, double 
		valuex, double valuey);
	
public:
	__fastcall virtual TVisTube(Classes::TComponent* aowner);
	__fastcall virtual ~TVisTube(void);
	virtual void __fastcall InitPoints(void);
	virtual void __fastcall InitPrimitives(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual TVisTubeSection* __fastcall AddLine(double dx, double dy, double dz, double radius)/* overload */
		;
	virtual TVisTubeSection* __fastcall AddLine(double dx, double dy, double dz, double radius, int stacks
		)/* overload */;
	virtual TVisTubeSection* __fastcall AddLine(double dx, double dy, double dz, double radius, int stacks
		, TRadChange RadChange)/* overload */;
	virtual TVisTubeSection* __fastcall AddBend(double dx, double dy, double dz, double radius)/* overload */
		;
	virtual TVisTubeSection* __fastcall AddBend(double dx, double dy, double dz, double radius, int stacks
		)/* overload */;
	virtual TVisTubeSection* __fastcall AddBend(double dx, double dy, double dz, double radius, int stacks
		, TRadChange RadChange)/* overload */;
	TVisTubeSection* __fastcall InsertLine(double dx, double dy, double dz, double radius, int stacks, 
		TRadChange RadChange, int index);
	TVisTubeSection* __fastcall InsertBend(double dx, double dy, double dz, double radius, int stacks, 
		TRadChange RadChange, int index);
	void __fastcall DeleteSection(int index);
	void __fastcall AddTube(TVisTube* aTube);
	void __fastcall Rebuild(void);
	void __fastcall Clear(void);
	TVisTubeSegment* __fastcall GetSegment(int index);
	Vismath::TVisMathVector __fastcall GetSegmentPos(int index);
	virtual Classes::TPersistent* __fastcall ReadComp(Visexchange::TVisExchange* exchange, Xmlparser::TXMLTag* 
		aTag);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	__property TVisTubeSection* Sections[int index] = {read=GetSection, write=SetSection};
	__property int SectionCount = {read=GetSegCount, nodefault};
	__property TVisTubeSegment* StartSegment = {read=GetStartSegment, write=SetStartSegment};
	
__published:
	__property int Slices = {read=FSlices, write=SetSlices, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE AnsiString VisTubeSectionTypeStr[2];
extern PACKAGE AnsiString RadChangeStr[4];
extern PACKAGE int eaNoChange;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Vistube */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vistube;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisTube
