// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VisView.pas' rev: 5.00

#ifndef VisViewHPP
#define VisViewHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VisComp.hpp>	// Pascal unit
#include <VisCanvasView.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <VisMath.hpp>	// Pascal unit
#include <VisExchange.hpp>	// Pascal unit
#include <VisCntrl.hpp>	// Pascal unit
#include <VisClass.hpp>	// Pascal unit
#include <VisGL.hpp>	// Pascal unit
#include <VisCam.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Visview
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TVisCoordinates;
class PASCALIMPLEMENTATION TVisCoordinates : public Visclass::TVisRenderProperty 
{
	typedef Visclass::TVisRenderProperty inherited;
	
private:
	bool FVisible;
	float FLength;
	Graphics::TColor FColorX;
	Graphics::TColor FColorY;
	Graphics::TColor FColorZ;
	void __fastcall WriteLength(Classes::TWriter* Writer);
	void __fastcall SetVisible(bool aValue);
	void __fastcall SetLength(float aValue);
	void __fastcall SetColor(int index, Graphics::TColor aValue);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TVisCoordinates(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Render(void);
	virtual void __fastcall WriteValues(Visexchange::TVisExchange* exchange);
	virtual void __fastcall ReadValues(Visexchange::TVisExchange* exchange);
	
__published:
	__property bool Visible = {read=FVisible, write=SetVisible, nodefault};
	__property float Length = {read=FLength, write=SetLength};
	__property Graphics::TColor ColorX = {read=FColorX, write=SetColor, index=0, nodefault};
	__property Graphics::TColor ColorY = {read=FColorY, write=SetColor, index=1, nodefault};
	__property Graphics::TColor ColorZ = {read=FColorZ, write=SetColor, index=2, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TVisCoordinates(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisName;
class PASCALIMPLEMENTATION TVisName : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	unsigned FID;
	
public:
	__property unsigned ID = {read=FID, write=FID, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TVisName(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TVisName(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVisSelection;
class PASCALIMPLEMENTATION TVisSelection : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FNames;
	float FZMin;
	float FZMax;
	int __fastcall GetCount(void);
	unsigned __fastcall GetNames(int Idx);
	
public:
	__fastcall virtual TVisSelection(void);
	__fastcall virtual ~TVisSelection(void);
	int __fastcall SetHitRecord(Visgl::PGLInt Values);
	bool __fastcall IsSelected(unsigned aName);
	void __fastcall Clear(void);
	__property float ZMin = {read=FZMin};
	__property float ZMax = {read=FZMax};
	__property int Count = {read=GetCount, nodefault};
	__property unsigned Names[int Idx] = {read=GetNames};
};


class DELPHICLASS TVisSelectionList;
class PASCALIMPLEMENTATION TVisSelectionList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FItems;
	int __fastcall GetCount(void);
	TVisSelection* __fastcall GetItems(int Idx);
	
public:
	__fastcall virtual TVisSelectionList(void);
	__fastcall virtual ~TVisSelectionList(void);
	void __fastcall SetHitRecords(Visgl::PGLInt Values, int Cnt);
	bool __fastcall IsSelected(unsigned aName);
	TVisSelection* __fastcall GetTopMost(void);
	void __fastcall Clear(void);
	__property int Count = {read=GetCount, nodefault};
	__property TVisSelection* Items[int Idx] = {read=GetItems};
};


class DELPHICLASS TVisView;
typedef void __fastcall (__closure *TVisViewRenderEvent)(TVisView* aView);

#pragma option push -b-
enum TVisDrawMode { dmWindow, dmBitmap, dmSelection, dmPick, dmNothing };
#pragma option pop

#pragma option push -b-
enum VisView__5 { btColor, btDepth };
#pragma option pop

typedef Set<VisView__5, btColor, btDepth>  TVisBufferType;

#pragma option push -b-
enum VisView__6 { dvRed, dvBlue, dvGreen, dvAlpha, dvDepth };
#pragma option pop

typedef Set<VisView__6, dvRed, dvDepth>  TVisDrawValues;

typedef void __fastcall (__closure *TVisNotifyNextID)(System::TObject* Obj, int num);

class PASCALIMPLEMENTATION TVisView : public Viscanvasview::TVisCanvasView 
{
	typedef Viscanvasview::TVisCanvasView inherited;
	
private:
	HDC FHDC;
	HGLRC FHGLRC;
	HPALETTE FWndPal;
	Graphics::TColor FBackgroundColor;
	TVisCoordinates* FCoordinates;
	Viscam::TVisCamera* FCamera;
	bool FDoubleBuffer;
	Windows::TPoint FSelectPoint;
	int FSelectWidth;
	int FSelectHeight;
	TVisViewRenderEvent FOnRender;
	TVisDrawMode FDrawMode;
	Viscntrl::TVisCustomController* FController;
	int FNextID;
	TVisNotifyNextID FOnGetNextID;
	int FSelectedID;
	int FSelID2;
	System::TObject* FSelObj;
	TVisBufferType FAutoClearBuffers;
	TVisDrawValues FDrawValues;
	bool FDepthTestEnabled;
	bool __fastcall OpenGLConnect(void);
	void __fastcall OpenGLDisconnect(void);
	bool __fastcall CreateRGBPalette(HDC aDC, HPALETTE &aPal);
	void __fastcall SetPixelFormat(HDC aDC, HPALETTE &aPal);
	void __fastcall InitCamera(int aWidth, int aHeight);
	void __fastcall SubChange(System::TObject* Sender);
	MESSAGE void __fastcall WMCreate(Messages::TWMCreate &Msg);
	HIDESBASE MESSAGE void __fastcall WMDestroy(Messages::TWMNoParams &Msg);
	bool __fastcall GetActive(void);
	bool __fastcall GetCurrent(void);
	void __fastcall SetCurrent(bool aValue);
	void __fastcall SetBackgroundColor(Graphics::TColor aValue);
	void __fastcall SetCoordinates(TVisCoordinates* aValue);
	void __fastcall SetCamera(Viscam::TVisCamera* aValue);
	void __fastcall SetDoubleBuffer(bool aValue);
	void __fastcall SetController(Viscntrl::TVisCustomController* aValue);
	MESSAGE void __fastcall CheckKey(Messages::TWMKey &Message);
	void __fastcall SetDrawValues(TVisDrawValues Value);
	void __fastcall SetDepthTestEnabled(bool Value);
	
protected:
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	DYNAMIC bool __fastcall PaletteChanged(bool Foreground);
	virtual void __fastcall Paint(void);
	virtual void __fastcall RenderScene(void);
	virtual void __fastcall RenderSceneGL(void);
	
public:
	__fastcall virtual TVisView(Classes::TComponent* aOwner);
	__fastcall virtual ~TVisView(void);
	void __fastcall InvalidateGL(void);
	bool __fastcall GetImage(Graphics::TBitmap* aBitmap);
	void __fastcall GetSelection(int x, int y, TVisSelectionList* Selections);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual Vismath::TVisMathVector __fastcall WinTo3D(int X, int Y, double depth);
	virtual Vismath::TVisMathVector __fastcall WinFrom3D(const Vismath::TVisMathVector &Value);
	virtual HDC __fastcall GetHDC(void);
	virtual int __fastcall GetNextID(System::TObject* Obj, int num);
	void __fastcall GetNextIdObj(System::TObject* aObj, int num);
	int __fastcall GetObj(int x, int y, System::TObject* &obj);
	bool __fastcall GetPoint(int x, int y, Vismath::TVisMathVector &point);
	Vismath::TVisMathVector __fastcall ProjectVector(Viscomp::TVisRender* SourceObj, const Vismath::TVisMathVector 
		&SourceVec);
	void __fastcall ClearBuffers(TVisBufferType Buffers);
	__property bool Current = {read=GetCurrent, write=SetCurrent, nodefault};
	__property HDC WindowDC = {read=GetHDC, nodefault};
	__property HGLRC OpenGLRC = {read=FHGLRC, nodefault};
	__property TVisDrawMode DrawMode = {read=FDrawMode, nodefault};
	__property TVisBufferType AutoClearBuffers = {read=FAutoClearBuffers, write=FAutoClearBuffers, nodefault
		};
	__property TVisDrawValues DrawValues = {read=FDrawValues, write=SetDrawValues, nodefault};
	__property bool DepthTestEnabled = {read=FDepthTestEnabled, write=SetDepthTestEnabled, nodefault};
	__property Canvas ;
	__property PopupMenu ;
	
__published:
	__property bool Active = {read=GetActive, nodefault};
	__property Graphics::TColor BackgroundColor = {read=FBackgroundColor, write=SetBackgroundColor, default=0
		};
	__property TVisCoordinates* Coordinates = {read=FCoordinates, write=SetCoordinates};
	__property Viscam::TVisCamera* Camera = {read=FCamera, write=SetCamera};
	__property bool DoubleBuffer = {read=FDoubleBuffer, write=SetDoubleBuffer, default=1};
	__property int SelectWidth = {read=FSelectWidth, write=FSelectWidth, default=5};
	__property int SelectHeight = {read=FSelectHeight, write=FSelectHeight, default=5};
	__property TVisViewRenderEvent OnRender = {read=FOnRender, write=FOnRender};
	__property Viscntrl::TVisCustomController* Controller = {read=FController, write=SetController};
	__property Align ;
	__property Color ;
	__property TabStop ;
	__property TabOrder ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnMouseWheel ;
	__property OnMouseWheelDown ;
	__property OnMouseWheelUp ;
	__property OnResize ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TVisView(HWND ParentWindow) : Viscanvasview::TVisCanvasView(
		ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const int DEFAULT_BACKGROUNDCOLOR = 0x0;
static const bool DEFAULT_DOUBLEBUFFER = true;
static const Shortint DEFAULT_SELECTWIDTH = 0x5;
static const Shortint DEFAULT_SELECTHEIGHT = 0x5;
extern PACKAGE void __fastcall AddViewtoList(TVisView* aView);
extern PACKAGE void __fastcall RemoveViewfromList(TVisView* aView);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Visview */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Visview;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VisView
