// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'XMLParser.pas' rev: 5.00

#ifndef XMLParserHPP
#define XMLParserHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Xmlparser
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TStates { stDefault, stOpenTag, stCloseTag, stValue, stParam, stSpecial, stComment };
#pragma option pop

class DELPHICLASS TXMLTag;
class PASCALIMPLEMENTATION TXMLTag : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString Name;
	AnsiString Value;
	AnsiString Param;
	int NameS;
	int NameE;
	int ParamE;
	int ValueE;
	int utags;
	int depth;
	int flag;
	TXMLTag* LastTag;
	System::TObject* Obj;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TXMLTag(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TXMLTag(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TTagEvent)(TXMLTag* &Tag);

typedef void __fastcall (__closure *TXMLProgressEvent)(const double progress);

class DELPHICLASS TXMLParser;
class PASCALIMPLEMENTATION TXMLParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	char *a;
	Classes::TMemoryStream* mem;
	TStates Fstate;
	AnsiString st;
	int Count;
	AnsiString FFileName;
	TXMLTag* Ftag;
	TXMLTag* FaTag;
	Classes::TStringList* FpList;
	TTagEvent FOnEndTag;
	TTagEvent FOnTag;
	TTagEvent FOnParam;
	TTagEvent FOnValue;
	TTagEvent FOnTagName;
	Classes::TGetStrProc FOnComment;
	TXMLProgressEvent FOnProgress;
	Classes::TGetStrProc FOnSpecial;
	void __fastcall OpenTag(void);
	void __fastcall Param(void);
	void __fastcall Value(void);
	void __fastcall Special(void);
	void __fastcall Comment(void);
	void __fastcall CloseTag(void);
	void __fastcall atEndtag(void);
	void __fastcall atTag(void);
	void __fastcall atParam(void);
	void __fastcall atValue(void);
	void __fastcall atTagName(void);
	void __fastcall atComment(void);
	void __fastcall atProgress(void);
	void __fastcall atSpecial(void);
	
public:
	void __fastcall execute(System::TObject* aObj);
	__fastcall virtual TXMLParser(Classes::TComponent* Owner);
	__fastcall virtual ~TXMLParser(void);
	__property Classes::TStringList* Params = {read=FpList};
	__property TXMLTag* Tag = {read=Ftag, write=Ftag};
	__property TXMLTag* aTag = {read=FaTag, write=FaTag};
	__property Classes::TMemoryStream* Stream = {read=mem, write=mem};
	__property TStates State = {read=Fstate, nodefault};
	
__published:
	__property TTagEvent OnEndTag = {read=FOnEndTag, write=FOnEndTag};
	__property TTagEvent OnTag = {read=FOnTag, write=FOnTag};
	__property TTagEvent OnParam = {read=FOnParam, write=FOnParam};
	__property TTagEvent OnValue = {read=FOnValue, write=FOnValue};
	__property Classes::TGetStrProc OnComment = {read=FOnComment, write=FOnComment};
	__property TTagEvent OnTagName = {read=FOnTagName, write=FOnTagName};
	__property TXMLProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
	__property Classes::TGetStrProc OnSpecial = {read=FOnSpecial, write=FOnSpecial};
	__property AnsiString FileName = {read=FFileName, write=FFileName};
};


//-- var, const, procedure ---------------------------------------------------
static const Word ProgressStep = 0x7d0;

}	/* namespace Xmlparser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Xmlparser;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// XMLParser
