//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VisAttr"
#pragma link "VisCam"
#pragma link "VisCanvasView"
#pragma link "VisClass"
#pragma link "VisComp"
#pragma link "VisGeom"
#pragma link "VisLight"
#pragma link "VisMat"
#pragma link "VisObj"
#pragma link "VisPrimitiveObj"
#pragma link "VisShape"
#pragma link "VisTimer"
#pragma link "VisView"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VisView1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  TObject *obj;
  VisView1->GetObj(X,Y,obj); //check if sphere was clicked
  if ((obj) && (obj->ClassType()==__classid(TVisSphere)))
   {
     DoDrag=true; //start dragging the sphere
     MousePos=Point(X,Y);
     OldPos=Point(X,Y);
     velocity.z=-0.05;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisView1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 if (DoDrag)
  {
   OldPos=MousePos; //update mouse position
   MousePos=Point(X,Y);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisView1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if (DoDrag) //drop the sphere:
  {
   DoDrag=false;
   //calculate velocity from old and current mouse position:
   velocity.x=(float)(MousePos.x-OldPos.x)/VisView1->Width;
   velocity.y=(float)(OldPos.y-MousePos.y)/VisView1->Height;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisView1Render(TVisView *aView)
{
 if (DoDrag) //if sphere is dragged then
   {

     //calculate the new position of the sphere:
     //1-((Z+2)/6) calculates the position between the clip planes in this special scene
     VisSphere1->Transformation->Translation->AsMathVector=VisView1->WinTo3D(MousePos.x,MousePos.y,1-((VisSphere1->Transformation->Translation->Z+2)/6.0));

     //keep the sphere inside the box:
//     VisSphere1->Transformation->Translation->X=Min((double)VisSphere1->Transformation->Translation->X,1-VisSphere1->Radius);
     if (VisSphere1->Transformation->Translation->X>1-VisSphere1->Radius)
        VisSphere1->Transformation->Translation->X=1-VisSphere1->Radius;
     if (VisSphere1->Transformation->Translation->X<VisSphere1->Radius-1)
        VisSphere1->Transformation->Translation->X=VisSphere1->Radius-1;
     if (VisSphere1->Transformation->Translation->Y>1-VisSphere1->Radius)
        VisSphere1->Transformation->Translation->Y=1-VisSphere1->Radius;
     if (VisSphere1->Transformation->Translation->Y<VisSphere1->Radius-1)
      VisSphere1->Transformation->Translation->Y=VisSphere1->Radius-1;
   }
 //move the second light with the sphere:
 VisLight1->Transformation->Translation->AsMathVector=VisSphere1->Transformation->Translation->AsMathVector;

 //Darken back wall:
 //The light is calculated by OpenGL based on its direction
 //and not on its distance. To achieve more realism the back
 //wall is darkened when the light is in the front.
 if (VisSphere1->Transformation->Translation->Z>0)
    VisMaterial2->ColorDiffuse->Color=(TColor)(0x00010101*Floor((2-VisSphere1->Radius-VisSphere1->Transformation->Translation->Z)/(2.0-VisSphere1->Radius)*255));
 else VisMaterial2->ColorDiffuse->Color=clWhite;

 //render all objects:
 VisNode1->Render(aView);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisSphere1AfterInit(TObject *Sender)
{
  velocity=ToVec(-0.05, 0.025, -0.04); //init velocity
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VisTimer1Timer(TObject *sender, int lagcount)
{
if (!DoDrag)  //move sphere if not dragged:
 {
   //move sphere:
   VisSphere1->Transformation->Translation->incX(velocity.x);
   VisSphere1->Transformation->Translation->incY(velocity.y);
   VisSphere1->Transformation->Translation->incZ(velocity.z);

   //check if walls have been hit:
   if (fabs(VisSphere1->Transformation->Translation->X)>(1-VisSphere1->Radius))
    {
     if (VisSphere1->Transformation->Translation->X>0)
        VisSphere1->Transformation->Translation->X=2-2*VisSphere1->Radius-VisSphere1->Transformation->Translation->X;
      else
        VisSphere1->Transformation->Translation->X=-2+2*VisSphere1->Radius-VisSphere1->Transformation->Translation->X;
     velocity.x=-velocity.x*0.9; //reverse moving direction and slow the sphere down
    }

  if (fabs(VisSphere1->Transformation->Translation->Y)>(1-VisSphere1->Radius))
    {

     if (VisSphere1->Transformation->Translation->Y>0)
        VisSphere1->Transformation->Translation->Y=2-2*VisSphere1->Radius-VisSphere1->Transformation->Translation->Y;
      else
        VisSphere1->Transformation->Translation->Y=-2+2*VisSphere1->Radius-VisSphere1->Transformation->Translation->Y;
     velocity.y=-velocity.y*0.9; //reverse moving direction and slow the sphere down
     if ((velocity.y<0.02)&&(VisSphere1->Transformation->Translation->Y<VisSphere1->Radius-0.9))//if sphere is on the ground then...
      {
        velocity.y=0;  //...stop bouncing.
        VisSphere1->Transformation->Translation->Y=VisSphere1->Radius-1;
      }
    }

  if (fabs(VisSphere1->Transformation->Translation->Z)>(2-VisSphere1->Radius))
    {
       if (VisSphere1->Transformation->Translation->Z>0)
         VisSphere1->Transformation->Translation->Z=4-2*VisSphere1->Radius-VisSphere1->Transformation->Translation->Z;
       else
         VisSphere1->Transformation->Translation->Z=-4+2*VisSphere1->Radius-VisSphere1->Transformation->Translation->Z;
       velocity.z=-velocity.z*0.9; //reverse moving direction and slow the sphere down
    }
   if ((velocity.y>0)||(VisSphere1->Transformation->Translation->Y>VisSphere1->Radius-1)) //add gravity force
      velocity.y=velocity.y-0.01;
 }
  VisView1->InvalidateGL();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Showgrid1Click(TObject *Sender)
{
 Showgrid1->Checked=!Showgrid1->Checked;
 if (Showgrid1->Checked)
   VisAttributes1->PolygonMode=pmLine;
 else
   VisAttributes1->PolygonMode=pmFill;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Highdetail1Click(TObject *Sender)
{
 Highdetail1->Checked=true;
 VisSphere1->Slices=32;
 VisBox1->DetailX=20;
 VisBox1->DetailY=10;
 VisBox1->DetailZ=20;
 VisRectangle1->DetailX=10;
 VisRectangle1->DetailY=10;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Lowdetail1Click(TObject *Sender)
{
 Lowdetail1->Checked=true;
 VisSphere1->Slices=16;
 VisBox1->DetailX=5;
 VisBox1->DetailY=5;
 VisBox1->DetailZ=5;
 VisRectangle1->DetailX=5;
 VisRectangle1->DetailY=5;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
  ShowAboutDlg();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Transparency1Click(TObject *Sender)
{
 Transparency1->Checked=!Transparency1->Checked;
 if (Transparency1->Checked)
   VisAttributes2->Transparency=tmAddAlpha;
 else
   VisAttributes2->Transparency=tmNone;

}
//---------------------------------------------------------------------------




