//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VisAttr"
#pragma link "VisCam"
#pragma link "VisCanvasView"
#pragma link "VisClass"
#pragma link "VisComp"
#pragma link "VisObj"
#pragma link "VisPrimitiveObj"
#pragma link "VisShape"
#pragma link "VisTex"
#pragma link "VisView"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
  Graphics::TBitmap *bmp;
  int a,b;
  MazeView->Current=true;
   bmp=new Graphics::TBitmap;
 bmp->Width=128; bmp->Height=128;
 bmp->Canvas->Brush->Color=clBlack;
 bmp->Canvas->FillRect(Rect(0,0,128,128));
 ShadowTex->Bitmap=bmp;
 ShadowTex->SetAlphaBitmap(MapTex->Bitmap);

 bmp->Width=220;   bmp->Height=220;
 for (a=0;a<=heightMaze+1;a++)
  for (b=0;b<=widthMaze+1;b++)
    {
      if (Maze[a][b]==fldWall)
        bmp->Canvas->Brush->Color=clBlack;
      else
        bmp->Canvas->Brush->Color=clWhite;
      bmp->Canvas->FillRect(Rect(b*10,a*10,(b+1)*10,(a+1)*10));
    }
 MapTex->Bitmap=bmp;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Box->Transformation->Scale->X=fac;
  Box->Transformation->Scale->Y=fac;
  Box->Transformation->Scale->Z=fac;
  Box->Init();
  MazeCamera->Transformation->Translation->Y=-fac / 2;

  Player.XPos=1;
  Player.ZPos=1;
  Player.Dir=dirDown;
  SetPlayerToMaze();
}
//---------------------------------------------------------------------------
void __fastcall Go(int *zp,int *xp, int zg,int xg)
  {
    if ((zg!=0)&&(Maze[*zp+zg][*xp]==fldWay))*zp+=zg;
    if ((xg!=0)&&(Maze[*zp][*xp+xg]==fldWay))*xp+=xg;
  }
//---------------------------------------------------------------------------
void __fastcall Turn(int *cDir,int aDir)
  {
    *cDir+=(aDir+4);
    *cDir%=4;
  }
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
  {
    int f=-1;
    switch(Key)
      {
        case VK_UP:  f=1;
        case VK_DOWN:
          if (Player.Dir==dirUp)   Go(&Player.ZPos,&Player.XPos,-1*f, 0);
          if (Player.Dir==dirDown) Go(&Player.ZPos,&Player.XPos, 1*f, 0);
          if (Player.Dir==dirLeft) Go(&Player.ZPos,&Player.XPos, 0,-1*f);
          if (Player.Dir==dirRight)Go(&Player.ZPos,&Player.XPos, 0, 1*f);
          break;
        case VK_LEFT:
        case VK_RIGHT:
          if (Key==VK_LEFT) Turn(&Player.Dir,-1);
          if (Key==VK_RIGHT)Turn(&Player.Dir,1);
          break;
        // move
      };
      UpdateViews();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MazeViewRender(TVisView *aView)
{
  MazeFog->Render(aView);
  mazeattr->Render(aView);
  GroundTex->Render(aView);
  DrawGround();
  WallTex->Render(aView);
  DrawBorders();
  MazeView->Canvas->Transparency=tmAlpha;
  MazeView->Canvas->DrawTexture(Bounds(20,20,128,128),MapTex,Rect(ceil((float)Player.XPos/widthMaze*256)-64,ceil((float)Player.ZPos/heightMaze*256)-64,floor((float)Player.XPos/widthMaze*256)+64,floor((float)Player.ZPos/heightMaze*256)+64));
  MazeView->Canvas->Brush->Color=clDkGray;
  MazeView->Canvas->DrawTexture(Bounds(20,20,128,128),ShadowTex,Bounds(0,0,128,128));
  MazeView->Canvas->FrameRect(Bounds(20,20,128,128));

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
  ShowAboutDlg();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetPlayerToMaze()
{
  // Players position
  MazeCamera->Transformation->Translation->X=-(fac * Player.XPos) - (fac / 2);
  MazeCamera->Transformation->Translation->Z=-(fac * Player.ZPos) - (fac / 2);
  // Players view direction
  switch (Player.Dir){
   case dirUp    : MazeCamera->Transformation->Rotation->Y=0;break;
   case dirDown  : MazeCamera->Transformation->Rotation->Y=180;break;
   case dirLeft  : MazeCamera->Transformation->Rotation->Y=-90;break;
   case dirRight : MazeCamera->Transformation->Rotation->Y=90;break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateViews(void)
{
   SetPlayerToMaze();
   MazeView->InvalidateGL();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawBorders()
{
  Box->Texture=WallTex;
  for(int x=1;x<=widthMaze-1;x++)
    for(int z=1;z<=heightMaze-1;z++)
     if (Maze[z][x]==fldWay)
     {
       for (int i=0;i<Box->PrimitiveCount;i++)
         Box->Primitive[i]->Enabled=false;
       if (Maze[z-1][x]==fldWall) Box->Primitive[2]->Enabled=true;
       if (Maze[z][x+1]==fldWall) Box->Primitive[3]->Enabled=true;
       if (Maze[z+1][x]==fldWall) Box->Primitive[0]->Enabled=true;
       if (Maze[z][x-1]==fldWall) Box->Primitive[1]->Enabled=true;
       Box->Transformation->Translation->X=x+0.5;
       Box->Transformation->Translation->Z=z;
       Box->Render(MazeView);
    }//if (Maze[z][x]==fldWay)
}//void TMainWnd::DrawBorders
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawGround()
{
  Box->Texture=GroundTex;
  for (int i=0;i<Box->PrimitiveCount;i++)
       Box->Primitive[i]->Enabled=false;
  Box->Primitive[4]->Enabled=true;
  for(int x=1;x<widthMaze;x++)
    for(int z=1;z<heightMaze;z++)
        if (Maze[z][x]==fldWay)
        {
          Box->Transformation->Translation->X=x+0.5;
          Box->Transformation->Translation->Z=z;
          Box->Render(MazeView);
        }//if (Maze[z][x]==fldWay)
}
//---------------------------------------------------------------------------


