//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "VisAttr.hpp"
#include "VisCam.hpp"
#include "VisCanvasView.hpp"
#include "VisClass.hpp"
#include "VisComp.hpp"
#include "VisObj.hpp"
#include "VisPrimitiveObj.hpp"
#include "VisShape.hpp"
#include "VisTex.hpp"
#include "VisAbout.hpp"
#include "VisView.hpp"
#include <Menus.hpp>
#include <Math.h>
//---------------------------------------------------------------------------
 struct TPlayer{
  int XPos,ZPos,Dir;
   };

const widthMaze  = 22;
const heightMaze = 22;
const float fac        = 0.5;
const fldWay     = 1;
const fldWall    = 0;
const dirUp      = 0;
const dirRight   = 1;
const dirDown    = 2;
const dirLeft    = 3;

   int Maze[heightMaze][widthMaze]=
        {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
         {0,1,1,0,1,1,0,1,0,1,0,1,1,1,0,1,1,1,1,1,1,0},
         {0,1,0,0,1,0,0,1,0,1,0,1,0,1,0,1,0,0,0,0,0,0},
         {0,1,0,1,1,1,1,1,0,1,0,1,0,1,0,1,0,1,1,1,0,0},
         {0,1,1,1,0,0,0,0,0,1,1,1,0,1,0,1,0,1,0,1,0,0},
         {0,0,0,1,0,1,1,1,1,1,0,1,0,1,0,1,0,1,0,1,0,0},
         {0,1,1,1,0,1,0,0,0,1,0,1,0,1,0,1,0,1,0,1,0,0},
         {0,1,0,0,0,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0},
         {0,1,1,1,1,1,0,0,1,0,1,0,0,1,0,0,0,0,0,1,0,0},
         {0,0,0,0,0,1,1,1,1,0,1,0,1,1,1,1,1,1,0,1,0,0},
         {0,1,1,1,0,1,0,0,0,0,1,0,0,0,0,0,0,1,0,1,0,0},
         {0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0},
         {0,1,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,1,1,1,1,0},
         {0,1,0,1,1,1,1,1,1,1,0,1,1,1,0,1,0,0,0,0,1,0},
         {0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,0},
         {0,1,0,1,1,1,0,1,0,1,1,1,0,1,0,0,0,0,0,0,1,0},
         {0,1,0,1,0,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0},
         {0,1,0,1,0,1,0,0,0,0,0,1,0,0,1,0,0,0,1,0,1,0},
         {0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0},
         {0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,1,0},
         {0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0},
         {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TVisView *MazeView;
        TVisTexture *GroundTex;
        TVisTexture *WallTex;
        TVisPerspectiveCamera *MazeCamera;
        TVisAttributes *mazeattr;
        TVisBox *Box;
        TVisFog *MazeFog;
        TVisTexture *MapTex;
        TVisTexture *ShadowTex;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *Help1;
        TMenuItem *About1;

        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall MazeViewRender(TVisView *aView);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall SetPlayerToMaze();
        void __fastcall UpdateViews(void);
        void __fastcall DrawBorders();
        void __fastcall DrawGround();
private:	// User declarations
        TPlayer Player;
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
   