//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VisAttr"
#pragma link "VisCam"
#pragma link "VisCanvasView"
#pragma link "VisClass"
#pragma link "VisCntrl"
#pragma link "VisComp"
#pragma link "VisGeom"                 F
#pragma link "VisLight"
#pragma link "VisMat"
#pragma link "VisObj"
#pragma link "VisPrimitiveObj"
#pragma link "VisShape"
#pragma link "VisTex"
#pragma link "VisTimer"
#pragma link "VisView"
#pragma resource "*.dfm"

struct TBoxData Boxes[10];//obstacles

TForm1 *Form1;
double __fastcall sqr(double value)
{
  return value*value;
}

void __fastcall CreateEnvironment()
{
 int a;
 for (a=0;a<=9;a++)
   {
     Boxes[a].Transform=ToVec(random(90)/100.0+0.1,random(90)/100.0+0.1,random(360));
     Boxes[a].Dims=ToVec(random(8)/100.0+0.02,random(10)/100.0+0.06,random(8)/100.0+0.02);
   }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 //init boxes
 speed=0.0;
 Randomize();
 CreateEnvironment();

 //init cam-pos
 RoboCam->Transformation->Rotation->Y=-RoboNode->Transformation->Rotation->Y;
 RoboCam->Transformation->Translation->X=-RoboNode->Transformation->Translation->X;
 RoboCam->Transformation->Translation->Z=-RoboNode->Transformation->Translation->Z;

 OVCam=false;

 VisView1->Canvas->Transparency=tmAlpha;
 VisView1->Canvas->Pen->Alpha=0.8;
 VisView1->Canvas->Font->Alpha=0.8;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VisView1Render(TVisView *aView)
{
  int a,r;
  TVisBox *CurBox;
  TVisMathVector p;

 //The scene is rendered mutiple times when performing GetPoint
 //To speed this up the fog, light, ground and textures are not
 //used in this case (DrawMode<>dmWindow).

 if (aView->DrawMode==dmWindow)
  {
   CurBox=Box; //full effects
   VisFog1->Render(aView);
   VisLight1->Render(aView);
   GroundRect->Render(aView);
  }
 else CurBox=FastBox; //no effects

 for (a=0;a<10;a++) //render obstacles
  {
   CurBox->Transformation->Translation->AsMathVector=ToVec(Boxes[a].Transform.x,0,Boxes[a].Transform.y);
   CurBox->Transformation->Rotation->Y=Boxes[a].Transform.z;
   CurBox->Width=Boxes[a].Dims.x;
   CurBox->Height=Boxes[a].Dims.y;
   CurBox->Depth=Boxes[a].Dims.z;
   CurBox->Render(aView);
  }
 //BoundBox is used as an outer wall during scanning
 if ((aView->DrawMode!=dmWindow)||(!OVCam))
   BoundBox->Render(aView);

 //The scanning is perfomed during rendering if possible to improve the
 //performance. This is only possible if the RoboCam is active.
 if (!OVCam)
   for (a=0;a<3;a++)
    { //scan
     VisView1->GetPoint(Floor((VisView1->Width/4.0)*(1+a)),VisView1->Height/2,p);
     SensorData[a]=sqrt(sqr(RoboNode->Transformation->Translation->Z-p.z)+sqr(RoboNode->Transformation->Translation->X-p.x));
    }

 if (aView->DrawMode==dmWindow)
  {
   RoboNode->Render(aView);  //draw robot
   if (aView->Camera->Name=="RoboCam")   //draw robot display
     {

      for (a=1;a<4;a++) //draw scan points:
       {
        if (SensorData[a-1]<0.15)
         aView->Canvas->Pen->Color=clRed;
        else
          aView->Canvas->Pen->Color=TColor(0x00111111);
        aView->Canvas->MoveTo(floor(aView->Width/4.0*a)-5,aView->Height/2);
        aView->Canvas->LineTo(floor(aView->Width/4.0*a)+5,aView->Height/2);
        aView->Canvas->MoveTo(floor(aView->Width/4.0*a),aView->Height/ 2-5);
        aView->Canvas->LineTo(floor(aView->Width/4.0*a),aView->Height/2+5);
        aView->Canvas->TextOut(floor(aView->Width/4.0*a)-13,aView->Height/2+16,FloatToStrF(SensorData[a-1],ffFixed,2,3));
       }
      //show direction:
      aView->Canvas->Brush->Alpha=0.3;
      aView->Canvas->Brush->Color=clWhite;
      aView->Canvas->Pen->Color=clBlack;

      r=aView->Width / 13;
      aView->Canvas->Ellipse(aView->Width-2*r-5, 5, aView->Width-5, 2*r+5);

      aView->Canvas->MoveTo(aView->Width-5-r, 5+r);

      aView->Canvas->Pen->Width=3;
      aView->Canvas->Pen->Color=clRed;
      aView->Canvas->Pen->Alpha=0.5;

      aView->Canvas->LineTo(floor(aView->Width-5-r-r*sin(RoboNode->Transformation->Rotation->Y/180.0*M_PI)),
             floor(5+r-r*cos(RoboNode->Transformation->Rotation->Y/180.0*M_PI)));
      //draw rectangles:
      aView->Canvas->Pen->Width=1;
      aView->Canvas->Pen->Alpha=0.8;
      aView->Canvas->Brush->Color=clWhite;
      aView->Canvas->Pen->Color=clBlack;
      aView->Canvas->Rectangle(Rect(3,4,146,27));
      aView->Canvas->Rectangle(Rect(146,4,171,27));
      aView->Canvas->Rectangle(Rect(aView->Width-2*r-50,4,aView->Width-2*r-10,27));
      aView->Canvas->Rectangle(Rect(aView->Width/2.0,4,aView->Width/2.0+80,27));
      aView->Canvas->Rectangle(Rect(aView->Width/2.0-50,aView->Height-37,aView->Width/2.0+50,aView->Height-14));
      aView->Canvas->Brush->Color=clRed;
      aView->Canvas->Brush->Alpha=0.5;
      //speed bar

      aView->Canvas->FillRect(Rect(5,5,5+speed*20000,25));

      //draw text
      aView->Canvas->TextOut(151,20,FloatToStrF(speed*10000/10,ffGeneral,1,2));
      aView->Canvas->TextOut(aView->Width-2*r-40,20,IntToStr((int)floor(RoboNode->Transformation->Rotation->Y))+'');
      aView->Canvas->TextOut(aView->Width/2.0-45,aView->Height-21,"FRAMERATE "+IntToStr(VisTimer1->FrameRate));
      if ((TurnAngle>=0)&&(speed==0))
       aView->Canvas->TextOut(aView->Width/2.0+20,20,"TURN");
      else if ((TurnAngle>=0)&&(speed!=0))
        aView->Canvas->TextOut(aView->Width/2.0+17,20,"BRAKE");
       else
         if (TurnAngle==-1)
           aView->Canvas->TextOut(aView->Width/2.0+5,20,"ACCELERATE");
     }
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::GroundRectAfterInit(TObject *Sender)
{
 //The texture of the ground is also used as a relief:
 if (Fulldetail1->Checked)
  GroundRect->SetReliefBitmap(VisTexture1->Bitmap,0.015,2,2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoxAfterInit(TObject *Sender)
{
 //when the detail is low the relief does not resemble the bitmap
 //but causes interesting distortions as for the obstacles:
 if (Fulldetail1->Checked)
  Box->SetReliefBitmap(VisTexture2->Bitmap,0.05,2,2);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::VisTimer1Timer(TObject *sender, int lagcount)
{
  TVisMathVector p;
  double m;
  int a;

  //The scanning is allways done (offscreen) from the robots
  //position:
  VisView1->Camera=RoboCam;

  //scan environment:
  if (TurnAngle==-1)
   {

    //The scanning is performed during rendering if the RoboCam is active.
    //In overview mode the scanning is done here:
    if (OVCam)
     for (a=0;a<3;a++)
      { //scan
       VisView1->GetPoint(floor((VisView1->Width/4.0)*(1+a)),VisView1->Height/2,p);
       SensorData[a]=sqrt(sqr(RoboNode->Transformation->Translation->Z-p.z)+sqr(RoboNode->Transformation->Translation->X-p.x));
      }
     m=SensorData[0];
     for (a=1;a<3;a++)//find least distance
      if (SensorData[a]<m)
        m=SensorData[a];

     //if the distance of the closest scanpoint is less then
     //0.15 then the robot turns to the left by 10 degrees:
     if (m<0.15) TurnAngle=10; //initialize turning
      else if (speed<0.007) speed=speed+0.0006; //accelerate
        else speed=speed+0.0005;
   }

   //turn vehicle
   if (TurnAngle>0)
    {
     RoboNode->Transformation->Rotation->incY(1);
     Wheel1->Transformation->Rotation->incZ(2);
     Wheel2->Transformation->Rotation->incZ(2);
     Wheel3->Transformation->Rotation->incZ(-2);
     Wheel4->Transformation->Rotation->incZ(-2);
    }
   if (TurnAngle>=0) TurnAngle--;

   //move vehicle
   if (speed>0)
    {
     speed=speed-0.0005;  //brake
     if (speed<0) speed=0;
     RoboNode->Transformation->Translation->incX(-speed*sin((float)RoboNode->Transformation->Rotation->Y/180.0*M_PI));
     RoboNode->Transformation->Translation->incZ(-speed*cos((float)RoboNode->Transformation->Rotation->Y/180.0*M_PI));
     m=-speed/0.13*360;
     Wheel1->Transformation->Rotation->incZ(m);
     Wheel2->Transformation->Rotation->incZ(m);
     Wheel3->Transformation->Rotation->incZ(m);
     Wheel4->Transformation->Rotation->incZ(m);
   }

   if (NoDetail1->Checked)
    { //flat ground
     RoboNode->Transformation->Rotation->X=0;
     RoboNode->Transformation->Rotation->Z=0;
    }
    else  //simulate bumbs
    {
     RoboNode->Transformation->Rotation->X=sin(RoboNode->Transformation->Rotation->Y/10.0+(RoboNode->Transformation->Translation->X+RoboNode->Transformation->Translation->Z)*100)*1;
     RoboNode->Transformation->Rotation->Z=sin(RoboNode->Transformation->Rotation->Y/10.0+(RoboNode->Transformation->Translation->X+RoboNode->Transformation->Translation->Z)*150)*1;
    }

   //move camera
   RoboCam->Transformation->Rotation->X=-RoboNode->Transformation->Rotation->X;
   RoboCam->Transformation->Rotation->Y=-RoboNode->Transformation->Rotation->Y;
   RoboCam->Transformation->Rotation->Z=-RoboNode->Transformation->Rotation->Z;
   RoboCam->Transformation->Translation->X=-RoboNode->Transformation->Translation->X;
   RoboCam->Transformation->Translation->Z=-RoboNode->Transformation->Translation->Z;

   //reset camera if overview is chosen:
   if (OVCam) VisView1->Camera=OverviewCam;

   VisView1->InvalidateGL(); //redraw the scene

}
//---------------------------------------------------------------------------

void __fastcall TForm1::New1Click(TObject *Sender)
{
 CreateEnvironment();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
 Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RoboCam1Click(TObject *Sender)
{
 //change camera to RoboCam
 OVCam=false;
 RoboCam1->Checked=true;
 VisFog1->EndDepth=0.5;
 RoboSphere->Enabled=false;
 Wheel1->Slices=20;
 Wheel3->Slices=20;
 Wheel2->Enabled=false;
 Wheel4->Enabled=false;
 VisView1->Controller=NULL;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::OverviewCam1Click(TObject *Sender)
{
 //change camera to overview:
 OVCam=true;
 OverviewCam1->Checked=true;
 VisFog1->EndDepth=2;
 RoboSphere->Enabled=true;
 Wheel1->Slices=8;
 Wheel3->Slices=8;
 Wheel2->Enabled=true;
 Wheel4->Enabled=true;
 VisView1->Controller=VisMouseController1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Fulldetail1Click(TObject *Sender)
{
 //full detail:
 Fulldetail1->Checked=true;
 Box->Textured=true;
 Box->DetailX=3; Box->DetailY=3; Box->DetailZ=3;
 Box->Material=NULL;

 //Only the detail of the FastBox is raised. Raising all
 //details would be little more accurate but much slower:
 FastBox->DetailY=3;
 GroundRect->Textured=true;
 //the high ground detail is necessary for the relief:
 GroundRect->DetailX=50; GroundRect->DetailY=50;
 GroundRect->Material=NULL;

 VisFog1->Enabled=true;
 //ViewFar can be low because the fog covers the scene:
 RoboCam->ViewFar=0.5;
 SceneAttr->ColorAmbient->Color=clYellow;
 SceneAttr->ShadeModel=smSmooth;
        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NoDetail1Click(TObject *Sender)
{
 //lower detail:
 NoDetail1->Checked=true;
 Box->Textured=false;
 Box->DetailX=1; Box->DetailY=1; Box->DetailZ=1;
 Box->Material=BoxMat;
 FastBox->DetailY=1;
 GroundRect->Textured=false;
 GroundRect->DetailX=1; GroundRect->DetailY=1;
 GroundRect->Material=GroundMat;

 VisFog1->Enabled=false;
 RoboCam->ViewFar=2;
 SceneAttr->ColorAmbient->Color=TColor(0x00111111);
 SceneAttr->ShadeModel=smFlat;
        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
  ShowAboutDlg();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AboutDemo1Click(TObject *Sender)
{
 Form2->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FastBoxAfterInit(TObject *Sender)
{
 //distort the FastBox (used only scanning) in the same
 //way like the displayed box:
 if (Fulldetail1->Checked)
  FastBox->SetReliefBitmap(VisTexture2->Bitmap,0.05,2,2);
}
//---------------------------------------------------------------------------

